/**
 *
 * @file chameleon_c.h
 *
 * @copyright 2009-2014 The University of Tennessee and The University of
 *                      Tennessee Research Foundation. All rights reserved.
 * @copyright 2012-2021 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
 *                      Univ. Bordeaux. All rights reserved.
 *
 ***
 *
 * @brief Chameleon CHAMELEON_complex32_t wrappers
 *
 * @version 1.1.0
 * @comment This file has been automatically generated
 *          from Plasma 2.5.0 for CHAMELEON 0.9.2
 * @author Jakub Kurzak
 * @author Hatem Ltaief
 * @author Azzam Haidar
 * @author Mathieu Faverge
 * @author Emmanuel Agullo
 * @author Cedric Castagnede
 * @author Florent Pruvost
 * @date 2021-03-17
 * @generated from /tmp/slackdce/slackrepo.gsXdbP/build_chameleon/chameleon-1.1.0/include/chameleon/chameleon_z.h, normal z -> c, Sat May 10 04:39:42 2025
 *
 */
#ifndef _chameleon_c_h_
#define _chameleon_c_h_

BEGIN_C_DECLS

/**
 *  Declarations of math functions (LAPACK layout) - alphabetical order
 */
int CHAMELEON_cgeadd(cham_trans_t trans, int M, int N, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t beta, CHAMELEON_Complex32_t *B, int LDB);
//int CHAMELEON_cgebrd(int M, int N, CHAMELEON_Complex32_t *A, int LDA, float *D, float *E, CHAM_desc_t *descT);
//int CHAMELEON_cgecon(cham_normtype_t norm, int N, CHAMELEON_Complex32_t *A, int LDA, float anorm, float *rcond);
//int CHAMELEON_cpocon(cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, float anorm, float *rcond);
int CHAMELEON_cgelqf(int M, int N, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT);
int CHAMELEON_cgelqs(int M, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cgels(cham_trans_t trans, int M, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT, CHAMELEON_Complex32_t *B, int LDB);
float CHAMELEON_cgenm2( float tol, int M, int N, CHAMELEON_Complex32_t *A, int LDA );
int CHAMELEON_cgemm(cham_trans_t transA, cham_trans_t transB, int M, int N, int K, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB, CHAMELEON_Complex32_t beta, CHAMELEON_Complex32_t *C, int LDC);
int CHAMELEON_cgepdf_qdwh( int M, int N, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *H, int LDH, gepdf_info_t *info );
int CHAMELEON_cgeqrf(int M, int N, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT);
int CHAMELEON_cgeqrs(int M, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT, CHAMELEON_Complex32_t *B, int LDB);
//int CHAMELEON_cgesv(int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, int *IPIV, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cgesv_incpiv(int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descL, int *IPIV, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cgesv_nopiv(int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cgesvd(cham_job_t jobu, cham_job_t jobvt, int M, int N, CHAMELEON_Complex32_t *A, int LDA, float *S, CHAM_desc_t *descT, CHAMELEON_Complex32_t *U, int LDU, CHAMELEON_Complex32_t *VT, int LDVT);
//int CHAMELEON_cgetrf(int M, int N, CHAMELEON_Complex32_t *A, int LDA, int *IPIV);
int CHAMELEON_cgetrf_incpiv(int M, int N, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descL, int *IPIV);
int CHAMELEON_cgetrf_nopiv(int M, int N, CHAMELEON_Complex32_t *A, int LDA);
//int CHAMELEON_cgetri(int N, CHAMELEON_Complex32_t *A, int LDA, int *IPIV);
//int CHAMELEON_cgetrs(cham_trans_t trans, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, int *IPIV, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cgetrs_incpiv(cham_trans_t trans, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descL, int *IPIV, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cgetrs_nopiv(cham_trans_t trans, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_chemm(cham_side_t side, cham_uplo_t uplo, int M, int N, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB, CHAMELEON_Complex32_t beta, CHAMELEON_Complex32_t *C, int LDC);
int CHAMELEON_cherk(cham_uplo_t uplo, cham_trans_t trans, int N, int K, float alpha, CHAMELEON_Complex32_t *A, int LDA, float beta, CHAMELEON_Complex32_t *C, int LDC);
int CHAMELEON_cher2k(cham_uplo_t uplo, cham_trans_t trans, int N, int K, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB, float beta, CHAMELEON_Complex32_t *C, int LDC);
//int CHAMELEON_cheev(cham_job_t jobz, cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, float *W, CHAM_desc_t *descT, CHAMELEON_Complex32_t *Q, int LDQ);
int CHAMELEON_cheevd(cham_job_t jobz, cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, float *W, CHAM_desc_t *descT);
//int CHAMELEON_chegv(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB, float *W, CHAM_desc_t *descT, CHAMELEON_Complex32_t *Q, int LDQ);
//int CHAMELEON_chegvd(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB, float *W, CHAM_desc_t *descT, CHAMELEON_Complex32_t *Q, int LDQ);
//int CHAMELEON_chegst(CHAMELEON_enum itype, cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_chetrd(cham_job_t jobz, cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, float *D, float *E, CHAM_desc_t *descT, CHAMELEON_Complex32_t *Q, int LDQ);
int CHAMELEON_clacpy(cham_uplo_t uplo, int M, int N, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
float CHAMELEON_clange(cham_normtype_t norm, int M, int N, CHAMELEON_Complex32_t *A, int LDA);
float CHAMELEON_clanhe(cham_normtype_t norm, cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA);
float CHAMELEON_clansy(cham_normtype_t norm, cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA);
float CHAMELEON_clantr(cham_normtype_t norm, cham_uplo_t uplo, cham_diag_t diag, int M, int N, CHAMELEON_Complex32_t *A, int LDA);
int CHAMELEON_clascal(cham_uplo_t uplo, int M, int N, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA);
int CHAMELEON_claset(cham_uplo_t uplo, int M, int N, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t beta, CHAMELEON_Complex32_t *A, int LDA);
//int CHAMELEON_claswp(int N, CHAMELEON_Complex32_t *A, int LDA, int K1, int K2, int *IPIV, int INCX);
//int CHAMELEON_claswpc(int N, CHAMELEON_Complex32_t *A, int LDA, int K1, int K2, int *IPIV, int INCX);
int CHAMELEON_clatms( int M, int N, cham_dist_t idist, unsigned long long int seed, cham_sym_t sym, float *D, int mode, float cond, float dmax, CHAMELEON_Complex32_t *A, int LDA );
int CHAMELEON_clauum(cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA);
int CHAMELEON_cplghe( float bump, cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, unsigned long long int seed );
int CHAMELEON_cplgsy( CHAMELEON_Complex32_t bump, cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, unsigned long long int seed );
int CHAMELEON_cplrnt( int M, int N, CHAMELEON_Complex32_t *A, int LDA, unsigned long long int seed );
int CHAMELEON_cplrnk( int M, int N, int K, CHAMELEON_Complex32_t *C, int LDC, unsigned long long int seedA, unsigned long long int seedB );
int CHAMELEON_cposv(cham_uplo_t uplo, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cpotrf(cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA);
int CHAMELEON_csytrf(cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA);
int CHAMELEON_cpotri(cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA);
int CHAMELEON_cpotrimm(cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB, CHAMELEON_Complex32_t *C, int LDC);
int CHAMELEON_cpotrs(cham_uplo_t uplo, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_csymm(cham_side_t side, cham_uplo_t uplo, int M, int N, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB, CHAMELEON_Complex32_t beta, CHAMELEON_Complex32_t *C, int LDC);
int CHAMELEON_csyrk(cham_uplo_t uplo, cham_trans_t trans, int N, int K, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t beta, CHAMELEON_Complex32_t *C, int LDC);
int CHAMELEON_csyr2k(cham_uplo_t uplo, cham_trans_t trans, int N, int K, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB, CHAMELEON_Complex32_t beta, CHAMELEON_Complex32_t *C, int LDC);
int CHAMELEON_csysv(cham_uplo_t uplo, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_csytrs(cham_uplo_t uplo, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_ctpgqrt( int M, int N, int K, int L, CHAMELEON_Complex32_t *V1, int LDV1, CHAM_desc_t *descT1, CHAMELEON_Complex32_t *V2, int LDV2, CHAM_desc_t *descT2, CHAMELEON_Complex32_t *Q1, int LDQ1, CHAMELEON_Complex32_t *Q2, int LDQ2 );
int CHAMELEON_ctpqrt( int M, int N, int L, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB, CHAM_desc_t *descT );
int CHAMELEON_ctradd(cham_uplo_t uplo, cham_trans_t trans, int M, int N, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t beta, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_ctrmm(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, int N, int NRHS, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_ctrsm(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, int N, int NRHS, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_ctrsmpl(int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descL, int *IPIV, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_ctrsmrv(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, int N, int NRHS, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int LDA, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_ctrtri(cham_uplo_t uplo, cham_diag_t diag, int N, CHAMELEON_Complex32_t *A, int LDA);
int CHAMELEON_cunglq(int M, int N, int K, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cungqr(int M, int N, int K, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cunmlq(cham_side_t side, cham_trans_t trans, int M, int N, int K, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cunmqr(cham_side_t side, cham_trans_t trans, int M, int N, int K, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT, CHAMELEON_Complex32_t *B, int LDB);

//int CHAMELEON_cgecfi(int m, int n, CHAMELEON_Complex32_t *A, CHAMELEON_enum fin, int imb, int inb, CHAMELEON_enum fout, int omb, int onb);
//int CHAMELEON_cgetmi(int m, int n, CHAMELEON_Complex32_t *A, CHAMELEON_enum fin, int mb,  int nb);

/**
 *  Declarations of math functions (tile layout) - alphabetical order
 */
int CHAMELEON_cgeadd_Tile(cham_trans_t trans, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAMELEON_Complex32_t beta, CHAM_desc_t *B);
//int CHAMELEON_cgebrd_Tile(CHAM_desc_t *A, float *D, float *E, CHAM_desc_t *T);
//int CHAMELEON_cgecon_Tile(cham_normtype_t norm, CHAM_desc_t *A, float anorm, float *rcond);
//int CHAMELEON_cpocon_Tile(cham_uplo_t uplo, CHAM_desc_t *A, float anorm, float *rcond);
int CHAMELEON_cgelqf_Tile(CHAM_desc_t *A, CHAM_desc_t *T);
int CHAMELEON_cgelqs_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_cgels_Tile(cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
float CHAMELEON_cgenm2_Tile( float tol, CHAM_desc_t *A );
int CHAMELEON_cgemm_Tile(cham_trans_t transA, cham_trans_t transB, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, CHAMELEON_Complex32_t beta, CHAM_desc_t *C);
int CHAMELEON_cgepdf_qdwh_Tile( CHAM_desc_t *A, CHAM_desc_t *H, gepdf_info_t *info );
int CHAMELEON_cgepdf_qr_Tile( int doqr, int optid, const libhqr_tree_t *qrtreeT, const libhqr_tree_t *qrtreeB, CHAM_desc_t *A1, CHAM_desc_t *TS1, CHAM_desc_t *TT1, CHAM_desc_t *Q1, CHAM_desc_t *A2, CHAM_desc_t *TS2, CHAM_desc_t *TT2, CHAM_desc_t *Q2 );
int CHAMELEON_cgeqrf_Tile(CHAM_desc_t *A, CHAM_desc_t *T);
int CHAMELEON_cgeqrs_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
//int CHAMELEON_cgesv_Tile(CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_cgesv_incpiv_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_cgesv_nopiv_Tile(CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_cgesvd_Tile(cham_job_t jobu, cham_job_t jobvt, CHAM_desc_t *A, float *S, CHAM_desc_t *T, CHAMELEON_Complex32_t *U, int LDU, CHAMELEON_Complex32_t *VT, int LDVT);
//int CHAMELEON_cgetrf_Tile(CHAM_desc_t *A, int *IPIV);
int CHAMELEON_cgetrf_incpiv_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV);
int CHAMELEON_cgetrf_nopiv_Tile(CHAM_desc_t *A);
//int CHAMELEON_cgetri_Tile(CHAM_desc_t *A, int *IPIV);
//int CHAMELEON_cgetrs_Tile(cham_trans_t trans, CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_cgetrs_incpiv_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_cgetrs_nopiv_Tile(CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_chemm_Tile(cham_side_t side, cham_uplo_t uplo, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, CHAMELEON_Complex32_t beta, CHAM_desc_t *C);
int CHAMELEON_cherk_Tile(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, float beta, CHAM_desc_t *C);
int CHAMELEON_cher2k_Tile(cham_uplo_t uplo, cham_trans_t trans, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C);
//int CHAMELEON_cheev_Tile(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *W, CHAM_desc_t *T, CHAMELEON_Complex32_t *Q, int LDQ);
int CHAMELEON_cheevd_Tile(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *W, CHAM_desc_t *T);
//int CHAMELEON_chegv_Tile( CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, float *W, CHAM_desc_t *T, CHAM_desc_t *Q);
//int CHAMELEON_chegvd_Tile(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, float *W, CHAM_desc_t *T, CHAM_desc_t *Q);
//int CHAMELEON_chegst_Tile(CHAMELEON_enum itype, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_chetrd_Tile(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *D, float *E, CHAM_desc_t *T, CHAMELEON_Complex32_t *Q, int LDQ);
int CHAMELEON_clacpy_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
float CHAMELEON_clange_Tile(cham_normtype_t norm, CHAM_desc_t *A);
float CHAMELEON_clanhe_Tile(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A);
float CHAMELEON_clansy_Tile(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A);
float CHAMELEON_clantr_Tile(cham_normtype_t norm, cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A);
int CHAMELEON_clascal_Tile(cham_uplo_t uplo, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A);
int CHAMELEON_claset_Tile(cham_uplo_t uplo, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t beta, CHAM_desc_t *A);
//int CHAMELEON_claswp_Tile(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX);
//int CHAMELEON_claswpc_Tile(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX);
int CHAMELEON_clatms_Tile( cham_dist_t idist, unsigned long long int seed, cham_sym_t sym, float *D, int mode, float cond, float dmax, CHAM_desc_t *A );
int CHAMELEON_clauum_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_cplghe_Tile(float bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed );
int CHAMELEON_cplgsy_Tile(CHAMELEON_Complex32_t bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed );
int CHAMELEON_cplrnt_Tile(CHAM_desc_t *A, unsigned long long int seed );
int CHAMELEON_cplrnk_Tile(int K, CHAM_desc_t *C, unsigned long long int seedA, unsigned long long int seedB );
int CHAMELEON_cposv_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_cpotrf_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_csytrf_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_cpotri_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_cpotrimm_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *C);
int CHAMELEON_cpotrs_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_csymm_Tile(cham_side_t side, cham_uplo_t uplo, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, CHAMELEON_Complex32_t beta, CHAM_desc_t *C);
int CHAMELEON_csyrk_Tile(cham_uplo_t uplo, cham_trans_t trans, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAMELEON_Complex32_t beta, CHAM_desc_t *C);
int CHAMELEON_csyr2k_Tile(cham_uplo_t uplo, cham_trans_t trans, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, CHAMELEON_Complex32_t beta, CHAM_desc_t *C);
int CHAMELEON_csysv_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_csytrs_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_ctpgqrt_Tile( int L, CHAM_desc_t *V1, CHAM_desc_t *T1, CHAM_desc_t *V2, CHAM_desc_t *T2, CHAM_desc_t *Q1, CHAM_desc_t *Q2 );
int CHAMELEON_ctpqrt_Tile( int L, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *T );
int CHAMELEON_ctradd_Tile(cham_uplo_t uplo, cham_trans_t trans, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAMELEON_Complex32_t beta, CHAM_desc_t *B);
int CHAMELEON_ctrmm_Tile(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_ctrsm_Tile(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_ctrsmpl_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_ctrsmrv_Tile(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_ctrtri_Tile(cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A);
int CHAMELEON_cunglq_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_cungqr_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_cunmlq_Tile(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_cunmqr_Tile(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);

/**
 *  Declarations of math functions (tile layout, asynchronous execution) - alphabetical order
 */
int CHAMELEON_cgeadd_Tile_Async(cham_trans_t trans, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAMELEON_Complex32_t beta, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_cgebrd_Tile_Async(CHAM_desc_t *A, float *D, float *E, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_cgecon_Tile_Async(cham_normtype_t norm, CHAM_desc_t *A, float anorm, float *rcond, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_cpocon_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, float anorm, float *rcond, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgelqf_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgelqs_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgels_Tile_Async(cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgenm2_Tile_Async( float tol, CHAM_desc_t *A, float *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_cgemm_Tile_Async(cham_trans_t transA, cham_trans_t transB, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, CHAMELEON_Complex32_t beta, CHAM_desc_t *C, void *ws, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgepdf_qdwh_Tile_Async( CHAM_desc_t *A, CHAM_desc_t *H, gepdf_info_t *info, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_cgeqrf_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgeqrs_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_cgesv_Tile_Async(CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgesv_incpiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgesv_nopiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgesvd_Tile_Async(cham_job_t jobu, cham_job_t jobvt, CHAM_desc_t *A, float *S, CHAM_desc_t *T, CHAMELEON_Complex32_t *U, int LDU, CHAMELEON_Complex32_t *VT, int LDVT, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_cgetrf_Tile_Async(CHAM_desc_t *A, int *IPIV, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgetrf_incpiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgetrf_nopiv_Tile_Async(CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_cgetri_Tile_Async(CHAM_desc_t *A, int *IPIV, CHAM_desc_t *W, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_cgetrs_Tile_Async(cham_trans_t trans, CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgetrs_incpiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgetrs_nopiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_chemm_Tile_Async(cham_side_t side, cham_uplo_t uplo, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, CHAMELEON_Complex32_t beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cherk_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, float beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cher2k_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_cheev_Tile_Async(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *W, CHAM_desc_t *T, CHAMELEON_Complex32_t *Q, int LDQ, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cheevd_Tile_Async(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *W, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_chegv_Tile_Async( CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, float *W, CHAM_desc_t *T, CHAM_desc_t *Q, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_chegvd_Tile_Async(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, float *W, CHAM_desc_t *T, CHAM_desc_t *Q, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_chegst_Tile_Async(CHAMELEON_enum itype, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_chetrd_Tile_Async(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *D, float *E, CHAM_desc_t *T, CHAMELEON_Complex32_t *Q, int LDQ, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_clacpy_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_clange_Tile_Async(cham_normtype_t norm, CHAM_desc_t *A, float *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_clanhe_Tile_Async(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A, float *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_clansy_Tile_Async(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A, float *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_clantr_Tile_Async(cham_normtype_t norm, cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A, float *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_clascal_Tile_Async(cham_uplo_t uplo, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_claset_Tile_Async(cham_uplo_t uplo, CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t beta, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_claswp_Tile_Async(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_claswpc_Tile_Async(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_clatms_Tile_Async( cham_dist_t idist, unsigned long long int seed, cham_sym_t sym, float *D, int mode, float cond, float dmax, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_clauum_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cplghe_Tile_Async(float bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_cplgsy_Tile_Async(CHAMELEON_Complex32_t bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_cplrnt_Tile_Async(CHAM_desc_t *A, unsigned long long int seed, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_cplrnk_Tile_Async(int K, CHAM_desc_t *C, unsigned long long int seedA, unsigned long long int seedB, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_cposv_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cpotrf_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_csytrf_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cpotri_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cpotrimm_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cpotrs_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_csysv_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_csytrs_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_csymm_Tile_Async(cham_side_t side, cham_uplo_t uplo, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, CHAMELEON_Complex32_t beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_csyrk_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAMELEON_Complex32_t beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_csyr2k_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, CHAMELEON_Complex32_t beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ctpgqrt_Tile_Async( int L, CHAM_desc_t *V1, CHAM_desc_t *T1, CHAM_desc_t *V2, CHAM_desc_t *T2, CHAM_desc_t *Q1, CHAM_desc_t *Q2, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_ctpqrt_Tile_Async( int L, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_ctradd_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAMELEON_Complex32_t beta, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ctrmm_Tile_Async(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ctrsm_Tile_Async(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ctrsmpl_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ctrsmrv_Tile_Async(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, CHAMELEON_Complex32_t alpha, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ctrtri_Tile_Async(cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cunglq_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cungqr_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cunmlq_Tile_Async(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cunmqr_Tile_Async(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);

//int CHAMELEON_cgecfi_Async(int m, int n, CHAMELEON_Complex32_t *A, CHAMELEON_enum f_in, int imb, int inb, CHAMELEON_enum f_out, int omb, int onb, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_cgetmi_Async(int m, int n, CHAMELEON_Complex32_t *A, CHAMELEON_enum f_in, int mb,  int inb, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);

/**
 *  Declarations of libhqr dependent functions.
 */
/**
 *  Declarations of math functions (LAPACK layout) - alphabetical order
 */
int CHAMELEON_cgels_param(const libhqr_tree_t *qrtree, cham_trans_t trans, int M, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cgelqf_param(const libhqr_tree_t *qrtree, int M, int N, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT);
int CHAMELEON_cgelqs_param(const libhqr_tree_t *qrtree, int M, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cgeqrf_param(const libhqr_tree_t *qrtree, int M, int N, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT);
int CHAMELEON_cgeqrs_param(const libhqr_tree_t *qrtree, int M, int N, int NRHS, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *TT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cunglq_param(const libhqr_tree_t *qrtree, int M, int N, int K, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *TT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cungqr_param(const libhqr_tree_t *qrtree, int M, int N, int K, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cunmlq_param(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, int M, int N, int K, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT, CHAM_desc_t *TT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cunmlq_param(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, int M, int N, int K, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descT, CHAM_desc_t *TT, CHAMELEON_Complex32_t *B, int LDB);
int CHAMELEON_cunmqr_param(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, int M, int N, int K, CHAMELEON_Complex32_t *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *TT, CHAMELEON_Complex32_t *B, int LDB);
/**
 *  Declarations of math functions (tile layout) - alphabetical order
 */
int CHAMELEON_cgels_param_Tile(const libhqr_tree_t *qrtree, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_cgelqf_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT);
int CHAMELEON_cgelqs_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_cgeqrf_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT);
int CHAMELEON_cgeqrs_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_cunglq_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_cungqr_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_cungqr_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_cunmlq_param_Tile(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_cunmqr_param_Tile(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
/**
 *  Declarations of math functions (tile layout, asynchronous execution) - alphabetical order
 */
int CHAMELEON_cgels_param_Tile_Async(const libhqr_tree_t *qrtree, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgelqf_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgelqs_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgeqrf_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cgeqrs_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cunglq_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cungqr_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cunmlq_param_Tile_Async(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_cunmqr_param_Tile_Async(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);

/**
 *  Declarations of workspace allocation functions (tile layout) - alphabetical order
 */
void *CHAMELEON_cgemm_WS_Alloc( cham_trans_t transA, cham_trans_t transB, const CHAM_desc_t *A, const CHAM_desc_t *B, const CHAM_desc_t *C );
void  CHAMELEON_cgemm_WS_Free( void *ws );
void *CHAMELEON_cgram_WS_Alloc( const CHAM_desc_t *A );
void  CHAMELEON_cgram_WS_Free( void *ws );

int CHAMELEON_Alloc_Workspace_cgesv_incpiv(        int N, CHAM_desc_t **descL, int **IPIV, int p, int q);
int CHAMELEON_Alloc_Workspace_cgetrf_incpiv(int M, int N, CHAM_desc_t **descL, int **IPIV, int p, int q);

int CHAMELEON_Alloc_Workspace_cgebrd(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_cgeev( int N,        CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_cgehrd(int N,        CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_cgelqf(int M, int N, CHAM_desc_t **T, int p, int q);
int CHAMELEON_Alloc_Workspace_cgels( int M, int N, CHAM_desc_t **T, int p, int q);
int CHAMELEON_Alloc_Workspace_cgeqrf(int M, int N, CHAM_desc_t **T, int p, int q);
int CHAMELEON_Alloc_Workspace_cgesvd(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_cheev( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_cheevd( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_chegv( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_chegvd( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_chetrd(int M, int N, CHAM_desc_t **descT, int p, int q);

/**
 *  Declarations of workspace allocation functions (tile layout, asynchronous execution) - alphabetical order
 */
int CHAMELEON_Alloc_Workspace_cgetri_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *W);

/* Warning: Those functions are deprecated */
int CHAMELEON_Alloc_Workspace_cgelqf_Tile(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_cgels_Tile( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_cgeqrf_Tile(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_cgesv_incpiv_Tile (int N, CHAM_desc_t **descL, int **IPIV, int p, int q);
int CHAMELEON_Alloc_Workspace_cgetrf_incpiv_Tile(int N, CHAM_desc_t **descL, int **IPIV, int p, int q);

/**
 *  Auxiliary function prototypes
 */
int CHAMELEON_cLapack_to_Tile( CHAMELEON_Complex32_t *Af77, int LDA, CHAM_desc_t *A ) __attribute__((deprecated("Please refer to CHAMELEON_cLap2Desc() instead")));
int CHAMELEON_cTile_to_Lapack( CHAM_desc_t *A, CHAMELEON_Complex32_t *Af77, int LDA ) __attribute__((deprecated("Please refer to CHAMELEON_cDesc2Lap() instead")));
int CHAMELEON_cLap2Desc( cham_uplo_t uplo, CHAMELEON_Complex32_t *Af77, int LDA, CHAM_desc_t *A );
int CHAMELEON_cDesc2Lap( cham_uplo_t uplo, CHAM_desc_t *A, CHAMELEON_Complex32_t *Af77, int LDA );

/**
 *  User Builder function prototypes
 */
int CHAMELEON_cbuild(cham_uplo_t uplo, int M, int N, CHAMELEON_Complex32_t *A, int LDA, void *user_data, void* user_build_callback);
int CHAMELEON_cbuild_Tile(cham_uplo_t uplo,  CHAM_desc_t *A, void *user_data, void* user_build_callback );
int CHAMELEON_cbuild_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, void *user_data, void* user_build_callback, RUNTIME_sequence_t *sequence, RUNTIME_request_t  *request);

/**
 * Gram function prototypes
 */
int CHAMELEON_cgram( cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA );
int CHAMELEON_cgram_Tile( cham_uplo_t uplo, CHAM_desc_t *A );
int CHAMELEON_cgram_Tile_Async( cham_uplo_t uplo, CHAM_desc_t *A, void *user_ws, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );

END_C_DECLS

#endif /* _chameleon_c_h_ */
