/**
 *
 * @file coreblas_c.h
 *
 * @copyright 2009-2014 The University of Tennessee and The University of
 *                      Tennessee Research Foundation. All rights reserved.
 * @copyright 2012-2021 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
 *                      Univ. Bordeaux. All rights reserved.
 *
 ***
 *
 * @brief Chameleon CPU CHAMELEON_Complex32_t kernels header
 *
 * @version 1.1.0
 * @comment This file has been automatically generated
 *          from Plasma 2.5.0 for CHAMELEON 0.9.2
 * @author Jakub Kurzak
 * @author Hatem Ltaief
 * @author Azzam Haidar
 * @author Mathieu Faverge
 * @author Emmanuel Agullo
 * @author Cedric Castagnede
 * @author Florent Pruvost
 * @date 2020-10-12
 * @generated from /tmp/slackdce/slackrepo.gsXdbP/build_chameleon/chameleon-1.1.0/coreblas/include/coreblas/coreblas_z.h, normal z -> c, Sat May 10 04:39:42 2025
 *
 */
#ifndef _coreblas_c_h_
#define _coreblas_c_h_

/**
 *  Declarations of serial kernels - alphabetical order
 */
void CORE_slag2c( cham_uplo_t uplo, int M, int N,
                  const float          *A, int lda,
                  CHAMELEON_Complex32_t *B, int ldb );
void CORE_scasum(cham_store_t storev, cham_uplo_t uplo, int M, int N,
                 const CHAMELEON_Complex32_t *A, int lda, float *work);
int CORE_caxpy(int M, CHAMELEON_Complex32_t alpha,
               const CHAMELEON_Complex32_t *A, int incA,
                     CHAMELEON_Complex32_t *B, int incB);
int CORE_cgeadd(cham_trans_t trans, int M, int N,
                      CHAMELEON_Complex32_t alpha,
                const CHAMELEON_Complex32_t *A, int LDA,
                      CHAMELEON_Complex32_t beta,
                      CHAMELEON_Complex32_t *B, int LDB);
int CORE_clascal( cham_uplo_t uplo, int m, int n,
              CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t *A, int lda );
int  CORE_cgelqt(int M, int N, int IB,
                 CHAMELEON_Complex32_t *A, int LDA,
                 CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *TAU,
                 CHAMELEON_Complex32_t *WORK);
void CORE_cgemm(cham_trans_t transA, cham_trans_t transB,
                int M, int N, int K,
                CHAMELEON_Complex32_t alpha, const CHAMELEON_Complex32_t *A, int LDA,
                                          const CHAMELEON_Complex32_t *B, int LDB,
                CHAMELEON_Complex32_t beta,        CHAMELEON_Complex32_t *C, int LDC);
void CORE_cgemv(cham_trans_t trans, int M, int N,
                CHAMELEON_Complex32_t alpha, const CHAMELEON_Complex32_t *A, int LDA,
                                             const CHAMELEON_Complex32_t *x, int incX,
                CHAMELEON_Complex32_t beta,        CHAMELEON_Complex32_t *y, int incY);
int  CORE_cgeqrt(int M, int N, int IB,
                 CHAMELEON_Complex32_t *A, int LDA,
                 CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *TAU, CHAMELEON_Complex32_t *WORK);
int CORE_cgesplit(cham_side_t side, cham_diag_t diag,
                  int M, int N,
                  CHAMELEON_Complex32_t *A, int LDA,
                  CHAMELEON_Complex32_t *B, int LDB);
int  CORE_cgessm(int M, int N, int K, int IB,
                 const int *IPIV,
                 const CHAMELEON_Complex32_t *L, int LDL,
                 CHAMELEON_Complex32_t *A, int LDA);
int  CORE_cgessq(cham_store_t storev, int M, int N,
                 const CHAMELEON_Complex32_t *A, int LDA,
                 float *sclssq);
int CORE_cgetf2_nopiv(int M, int N,
                  CHAMELEON_Complex32_t *A, int LDA);
int  CORE_cgetrf(int M, int N,
                 CHAMELEON_Complex32_t *A, int LDA,
                 int *IPIV, int *INFO);
int  CORE_cgetrf_incpiv(int M, int N, int IB,
                        CHAMELEON_Complex32_t *A, int LDA,
                        int *IPIV, int *INFO);
int CORE_cgetrf_nopiv(int M, int N, int IB,
                      CHAMELEON_Complex32_t *A, int LDA,
                      int *INFO);
int  CORE_cgetrf_reclap(int M, int N,
                        CHAMELEON_Complex32_t *A, int LDA,
                        int *IPIV, int *info);
int  CORE_cgetrf_rectil(const CHAM_desc_t A, int *IPIV, int *info);
void CORE_cgetrip(int m, int n, CHAMELEON_Complex32_t *A,
                  CHAMELEON_Complex32_t *work);
void CORE_che2ge(cham_uplo_t uplo, int M, int N,
                 const CHAMELEON_Complex32_t *A, int LDA,
                 CHAMELEON_Complex32_t *B, int LDB);
void CORE_chegst(int itype, cham_uplo_t uplo, int N,
                 CHAMELEON_Complex32_t *A, int LDA,
                 CHAMELEON_Complex32_t *B, int LDB, int *INFO);
void CORE_chemm(cham_side_t side, cham_uplo_t uplo,
                int M, int N,
                CHAMELEON_Complex32_t alpha, const CHAMELEON_Complex32_t *A, int LDA,
                                          const CHAMELEON_Complex32_t *B, int LDB,
                CHAMELEON_Complex32_t beta,        CHAMELEON_Complex32_t *C, int LDC);
void CORE_cherk(cham_uplo_t uplo, cham_trans_t trans,
                int N, int K,
                float alpha, const CHAMELEON_Complex32_t *A, int LDA,
                float beta,        CHAMELEON_Complex32_t *C, int LDC);
void CORE_cher2k(cham_uplo_t uplo, cham_trans_t trans,
                 int N, int K,
                 CHAMELEON_Complex32_t alpha, const CHAMELEON_Complex32_t *A, int LDA,
                                           const CHAMELEON_Complex32_t *B, int LDB,
                 float beta,                    CHAMELEON_Complex32_t *C, int LDC);
int  CORE_chessq(cham_store_t storev, cham_uplo_t uplo, int N,
                 const CHAMELEON_Complex32_t *A, int LDA,
                 float *sclssq);
int  CORE_cherfb(cham_uplo_t uplo, int N, int K, int IB, int NB,
                 const CHAMELEON_Complex32_t *A,    int LDA,
                 const CHAMELEON_Complex32_t *T,    int LDT,
                       CHAMELEON_Complex32_t *C,    int LDC,
                       CHAMELEON_Complex32_t *WORK, int LDWORK);
void CORE_clacpy(cham_uplo_t uplo, int M, int N,
                 const CHAMELEON_Complex32_t *A, int LDA,
                       CHAMELEON_Complex32_t *B, int LDB);
void CORE_clange(cham_normtype_t norm, int M, int N,
                 const CHAMELEON_Complex32_t *A, int LDA,
                 float *work, float *normA);
void CORE_clanhe(cham_normtype_t norm, cham_uplo_t uplo, int N,
                 const CHAMELEON_Complex32_t *A, int LDA,
                 float *work, float *normA);
void CORE_clansy(cham_normtype_t norm, cham_uplo_t uplo, int N,
                 const CHAMELEON_Complex32_t *A, int LDA,
                 float *work, float *normA);
void CORE_clantr(cham_normtype_t norm, cham_uplo_t uplo, cham_diag_t diag, int M, int N,
                 const CHAMELEON_Complex32_t *A, int LDA,
                 float *work, float *normA);
int CORE_clarfb_gemm(cham_side_t side, cham_trans_t trans, cham_dir_t direct, cham_store_t storev,
                     int M, int N, int K,
                     const CHAMELEON_Complex32_t *V, int LDV,
                     const CHAMELEON_Complex32_t *T, int LDT,
                           CHAMELEON_Complex32_t *C, int LDC,
                           CHAMELEON_Complex32_t *WORK, int LDWORK);
int CORE_clarfx2(cham_side_t side, int N,
                 CHAMELEON_Complex32_t V,
                 CHAMELEON_Complex32_t TAU,
                 CHAMELEON_Complex32_t *C1, int LDC1,
                 CHAMELEON_Complex32_t *C2, int LDC2);
int CORE_clarfx2c(cham_uplo_t uplo,
                  CHAMELEON_Complex32_t V,
                  CHAMELEON_Complex32_t TAU,
                  CHAMELEON_Complex32_t *C1,
                  CHAMELEON_Complex32_t *C2,
                  CHAMELEON_Complex32_t *C3);
int CORE_clarfx2ce(cham_uplo_t uplo,
                   CHAMELEON_Complex32_t *V,
                   CHAMELEON_Complex32_t *TAU,
                   CHAMELEON_Complex32_t *C1,
                   CHAMELEON_Complex32_t *C2,
                   CHAMELEON_Complex32_t *C3);
void CORE_clarfy(int N,
                 CHAMELEON_Complex32_t *A, int LDA,
                 const CHAMELEON_Complex32_t *V,
                 const CHAMELEON_Complex32_t *TAU,
                 CHAMELEON_Complex32_t *WORK);
void CORE_claset(cham_uplo_t uplo, int n1, int n2,
                 CHAMELEON_Complex32_t alpha, CHAMELEON_Complex32_t beta,
                 CHAMELEON_Complex32_t *tileA, int ldtilea);
void CORE_claset2(cham_uplo_t uplo, int n1, int n2, CHAMELEON_Complex32_t alpha,
                  CHAMELEON_Complex32_t *tileA, int ldtilea);
void CORE_claswp(int N, CHAMELEON_Complex32_t *A, int LDA,
                 int I1,  int I2, const int *IPIV, int INC);
int  CORE_claswp_ontile( CHAM_desc_t descA, int i1, int i2, const int *ipiv, int inc);
int  CORE_claswpc_ontile(CHAM_desc_t descA, int i1, int i2, const int *ipiv, int inc);
int  CORE_clatro(cham_uplo_t uplo, cham_trans_t trans,
                 int M, int N,
                 const CHAMELEON_Complex32_t *A, int LDA,
                       CHAMELEON_Complex32_t *B, int LDB);
int CORE_clatm1( int MODE, float COND, int IRSIGN, cham_dist_t DIST,
                 unsigned long long int seed,
                 CHAMELEON_Complex32_t *D, int N );
void CORE_clauum(cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA);
int CORE_cpamm(int op, cham_side_t side, cham_store_t storev,
               int M, int N, int K, int L,
               const CHAMELEON_Complex32_t *A1, int LDA1,
                     CHAMELEON_Complex32_t *A2, int LDA2,
               const CHAMELEON_Complex32_t *V, int LDV,
                     CHAMELEON_Complex32_t *W, int LDW);
int  CORE_cparfb(cham_side_t side, cham_trans_t trans, cham_dir_t direct, cham_store_t storev,
                 int M1, int N1, int M2, int N2, int K, int L,
                       CHAMELEON_Complex32_t *A1, int LDA1,
                       CHAMELEON_Complex32_t *A2, int LDA2,
                 const CHAMELEON_Complex32_t *V, int LDV,
                 const CHAMELEON_Complex32_t *T, int LDT,
                       CHAMELEON_Complex32_t *WORK, int LDWORK);
int CORE_cpemv(cham_trans_t trans, cham_store_t storev,
               int M, int N, int L,
               CHAMELEON_Complex32_t ALPHA,
               const CHAMELEON_Complex32_t *A, int LDA,
               const CHAMELEON_Complex32_t *X, int INCX,
               CHAMELEON_Complex32_t BETA,
               CHAMELEON_Complex32_t *Y, int INCY,
               CHAMELEON_Complex32_t *WORK);
void CORE_cplghe(float bump, int m, int n, CHAMELEON_Complex32_t *A, int lda,
                 int bigM, int m0, int n0, unsigned long long int seed );
void CORE_cplgsy(CHAMELEON_Complex32_t bump, int m, int n, CHAMELEON_Complex32_t *A, int lda,
                 int bigM, int m0, int n0, unsigned long long int seed );
void CORE_cplrnt(int m, int n, CHAMELEON_Complex32_t *A, int lda,
                 int bigM, int m0, int n0, unsigned long long int seed );
int CORE_cplssq( cham_store_t storev, int M, int N,
                 float *sclssqin, float *sclssqout );
int CORE_cplssq2( int N, float *sclssq );
void CORE_cpotrf(cham_uplo_t uplo, int N, CHAMELEON_Complex32_t *A, int LDA, int *INFO);
void CORE_cshift(int s, int m, int n, int L,
                 CHAMELEON_Complex32_t *A);
void CORE_cshiftw(int s, int cl, int m, int n, int L,
                  CHAMELEON_Complex32_t *A, CHAMELEON_Complex32_t *W);
int  CORE_cssssm(int M1, int N1, int M2, int N2, int K, int IB,
                       CHAMELEON_Complex32_t *A1, int LDA1,
                       CHAMELEON_Complex32_t *A2, int LDA2,
                 const CHAMELEON_Complex32_t *L1, int LDL1,
                 const CHAMELEON_Complex32_t *L2, int LDL2,
                 const int *IPIV);
void CORE_csymm(cham_side_t side, cham_uplo_t uplo,
                int M, int N,
                CHAMELEON_Complex32_t alpha, const CHAMELEON_Complex32_t *A, int LDA,
                                          const CHAMELEON_Complex32_t *B, int LDB,
                CHAMELEON_Complex32_t beta,        CHAMELEON_Complex32_t *C, int LDC);
void CORE_csyrk(cham_uplo_t uplo, cham_trans_t trans,
                int N, int K,
                CHAMELEON_Complex32_t alpha, const CHAMELEON_Complex32_t *A, int LDA,
                CHAMELEON_Complex32_t beta,        CHAMELEON_Complex32_t *C, int LDC);
void CORE_csyr2k(cham_uplo_t uplo, cham_trans_t trans,
                 int N, int K,
                 CHAMELEON_Complex32_t alpha, const CHAMELEON_Complex32_t *A, int LDA,
                                           const CHAMELEON_Complex32_t *B, int LDB,
                 CHAMELEON_Complex32_t beta,        CHAMELEON_Complex32_t *C, int LDC);
int  CORE_csyssq(cham_store_t storev, cham_uplo_t uplo, int N,
                 const CHAMELEON_Complex32_t *A, int LDA,
                 float *sclssq);
int CORE_csytf2_nopiv(cham_uplo_t uplo, int n, CHAMELEON_Complex32_t *A, int lda);
int CORE_ctradd(cham_uplo_t uplo, cham_trans_t trans, int M, int N,
                      CHAMELEON_Complex32_t alpha,
                const CHAMELEON_Complex32_t *A, int LDA,
                      CHAMELEON_Complex32_t beta,
                      CHAMELEON_Complex32_t *B, int LDB);
void CORE_ctrasm(cham_store_t storev, cham_uplo_t uplo, cham_diag_t diag,
                 int M, int N,
                 const CHAMELEON_Complex32_t *A, int lda, float *work);
void CORE_ctrmm(cham_side_t side, cham_uplo_t uplo,
                cham_trans_t transA, cham_diag_t diag,
                int M, int N,
                CHAMELEON_Complex32_t alpha, const CHAMELEON_Complex32_t *A, int LDA,
                                                CHAMELEON_Complex32_t *B, int LDB);
void CORE_ctrsm(cham_side_t side, cham_uplo_t uplo,
                cham_trans_t transA, cham_diag_t diag,
                int M, int N,
                CHAMELEON_Complex32_t alpha, const CHAMELEON_Complex32_t *A, int LDA,
                                                CHAMELEON_Complex32_t *B, int LDB);
int CORE_ctrssq(cham_uplo_t uplo, cham_diag_t diag, int M, int N,
                const CHAMELEON_Complex32_t *A, int LDA,
                float *scale, float *sumsq);
void CORE_ctrtri(cham_uplo_t uplo, cham_diag_t diag, int N,
                 CHAMELEON_Complex32_t *A, int LDA, int *info);
int  CORE_ctslqt(int M, int N, int IB,
                 CHAMELEON_Complex32_t *A1, int LDA1,
                 CHAMELEON_Complex32_t *A2, int LDA2,
                 CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *TAU, CHAMELEON_Complex32_t *WORK);
int  CORE_ctsmlq(cham_side_t side, cham_trans_t trans,
                 int M1, int N1, int M2, int N2, int K, int IB,
                 CHAMELEON_Complex32_t *A1, int LDA1,
                 CHAMELEON_Complex32_t *A2, int LDA2,
                 const CHAMELEON_Complex32_t *V, int LDV,
                 const CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *WORK, int LDWORK);
int CORE_ctsmlq_hetra1( cham_side_t side, cham_trans_t trans,
                        int m1, int n1, int m2, int n2,
                        int k, int ib,
                        CHAMELEON_Complex32_t *A1, int lda1,
                        CHAMELEON_Complex32_t *A2, int lda2,
                        const CHAMELEON_Complex32_t *V, int ldv,
                        const CHAMELEON_Complex32_t *T, int ldt,
                        CHAMELEON_Complex32_t *WORK, int ldwork);
int  CORE_ctsmqr(cham_side_t side, cham_trans_t trans,
                 int M1, int N1, int M2, int N2, int K, int IB,
                 CHAMELEON_Complex32_t *A1, int LDA1,
                 CHAMELEON_Complex32_t *A2, int LDA2,
                 const CHAMELEON_Complex32_t *V, int LDV,
                 const CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *WORK, int LDWORK);
int CORE_ctsmqr_hetra1( cham_side_t side, cham_trans_t trans,
                        int m1, int n1, int m2, int n2,
                        int k, int ib,
                        CHAMELEON_Complex32_t *A1, int lda1,
                        CHAMELEON_Complex32_t *A2, int lda2,
                        const CHAMELEON_Complex32_t *V, int ldv,
                        const CHAMELEON_Complex32_t *T, int ldt,
                        CHAMELEON_Complex32_t *WORK, int ldwork);
int  CORE_ctsqrt(int M, int N, int IB,
                 CHAMELEON_Complex32_t *A1, int LDA1,
                 CHAMELEON_Complex32_t *A2, int LDA2,
                 CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *TAU, CHAMELEON_Complex32_t *WORK);
int  CORE_ctstrf(int M, int N, int IB, int NB,
                 CHAMELEON_Complex32_t *U, int LDU,
                 CHAMELEON_Complex32_t *A, int LDA,
                 CHAMELEON_Complex32_t *L, int LDL,
                 int *IPIV, CHAMELEON_Complex32_t *WORK,
                 int LDWORK, int *INFO);
int CORE_ctplqt( int M, int N, int L, int IB,
                 CHAMELEON_Complex32_t *A, int LDA,
                 CHAMELEON_Complex32_t *B, int LDB,
                 CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *WORK );
int CORE_ctpmlqt( cham_side_t side, cham_trans_t trans,
                  int M, int N, int K, int L, int IB,
                  const CHAMELEON_Complex32_t *V, int LDV,
                  const CHAMELEON_Complex32_t *T, int LDT,
                  CHAMELEON_Complex32_t *A, int LDA,
                  CHAMELEON_Complex32_t *B, int LDB,
                  CHAMELEON_Complex32_t *WORK );
int CORE_ctpmqrt( cham_side_t side, cham_trans_t trans,
                  int M, int N, int K, int L, int IB,
                  const CHAMELEON_Complex32_t *V, int LDV,
                  const CHAMELEON_Complex32_t *T, int LDT,
                  CHAMELEON_Complex32_t *A, int LDA,
                  CHAMELEON_Complex32_t *B, int LDB,
                  CHAMELEON_Complex32_t *WORK );
int CORE_ctpqrt( int M, int N, int L, int IB,
                 CHAMELEON_Complex32_t *A, int LDA,
                 CHAMELEON_Complex32_t *B, int LDB,
                 CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *WORK );
int  CORE_cttmqr(cham_side_t side, cham_trans_t trans,
                 int M1, int N1, int M2, int N2, int K, int IB,
                 CHAMELEON_Complex32_t *A1, int LDA1,
                 CHAMELEON_Complex32_t *A2, int LDA2,
                 const CHAMELEON_Complex32_t *V, int LDV,
                 const CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *WORK, int LDWORK);
int  CORE_cttqrt(int M, int N, int IB,
                 CHAMELEON_Complex32_t *A1, int LDA1,
                 CHAMELEON_Complex32_t *A2, int LDA2,
                 CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *TAU,
                 CHAMELEON_Complex32_t *WORK);
int  CORE_cttmlq(cham_side_t side, cham_trans_t trans,
                 int M1, int N1, int M2, int N2, int K, int IB,
                 CHAMELEON_Complex32_t *A1, int LDA1,
                 CHAMELEON_Complex32_t *A2, int LDA2,
                 const CHAMELEON_Complex32_t *V, int LDV,
                 const CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *WORK, int LDWORK);
int  CORE_cttlqt(int M, int N, int IB,
                 CHAMELEON_Complex32_t *A1, int LDA1,
                 CHAMELEON_Complex32_t *A2, int LDA2,
                 CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *TAU,
                 CHAMELEON_Complex32_t *WORK);
int  CORE_cunmlq(cham_side_t side, cham_trans_t trans,
                 int M, int N, int IB, int K,
                 const CHAMELEON_Complex32_t *V, int LDV,
                 const CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *C, int LDC,
                 CHAMELEON_Complex32_t *WORK, int LDWORK);
int  CORE_cunmqr(cham_side_t side, cham_trans_t trans,
                 int M, int N, int K, int IB,
                 const CHAMELEON_Complex32_t *V, int LDV,
                 const CHAMELEON_Complex32_t *T, int LDT,
                 CHAMELEON_Complex32_t *C, int LDC,
                 CHAMELEON_Complex32_t *WORK, int LDWORK);

/**
 * Gram prototypes
 */
int CORE_cgram( cham_uplo_t uplo, int M, int N, int Mt, int Nt,
                const float *Di, int LDDI,
                const float *Dj, int LDDJ,
                const float *D,
                float *A, int LDA );

#endif /* _coreblas_c_h_ */
