set(CHAMELEON_VERSION 1.1.0)

# relocatable package

####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was CHAMELEONConfig.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib64/cmake/chameleon" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

set_and_check(CHAMELEON_BIN_DIR "${PACKAGE_PREFIX_DIR}/libexec/chameleon")
set_and_check(CHAMELEON_INC_DIR "${PACKAGE_PREFIX_DIR}/include/")
set_and_check(CHAMELEON_LIB_DIR "${PACKAGE_PREFIX_DIR}/lib64")

check_required_components(CHAMELEON)

# need MORSE Find modules: necessary files must be distributed in the install path
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/find")

# dependencies of CHAMELEON
include(CMakeFindDependencyMacro)
find_dependency(M)
if (NOT )
  find_dependency(CBLAS REQUIRED)
  find_dependency(LAPACKE REQUIRED)
endif()
if (ON)
  find_dependency(OpenMP REQUIRED)
endif()
if (OFF)
  find_dependency(PARSEC REQUIRED)
endif()
if (OFF)
  find_dependency(QUARK REQUIRED COMPONENTS HWLOC)
endif()
if (OFF)
  find_package(STARPU  REQUIRED)
endif()
if (OFF)
  find_dependency(MPI REQUIRED)
endif()
if (OFF AND NOT )
  find_dependency(CUDA REQUIRED)
  if ( CUDA_FOUND )
    if (NOT TARGET CUDA::CUDA)
      add_library(CUDA::CUDA INTERFACE IMPORTED)
      if (CUDA_INCLUDE_DIRS)
        set_target_properties(CUDA::CUDA PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${CUDA_INCLUDE_DIRS}")
      endif()
      if (CUDA_LIBRARIES)
        set_target_properties(CUDA::CUDA PROPERTIES INTERFACE_LINK_LIBRARIES "${CUDA_LIBRARIES}")
      endif()
      if (NOT TARGET CUDA::CUBLAS)
        add_library(CUDA::CUBLAS INTERFACE IMPORTED)
        if (CUDA_CUBLAS_LIBRARIES)
          set_target_properties(CUDA::CUBLAS PROPERTIES INTERFACE_LINK_LIBRARIES "${CUDA_CUBLAS_LIBRARIES}")
        endif()
        target_link_libraries(CUDA::CUBLAS INTERFACE CUDA::CUDA)
      endif()
    endif()
  endif()
endif()

# add the targets file
include("${CMAKE_CURRENT_LIST_DIR}/../hqr/hqrTargets.cmake")
if (NOT )
  include("${CMAKE_CURRENT_LIST_DIR}/coreblasTargets.cmake")
endif()
if (OFF AND NOT )
  include("${CMAKE_CURRENT_LIST_DIR}/cudablasTargets.cmake")
endif()
if (ON)
  include("${CMAKE_CURRENT_LIST_DIR}/chameleon_openmpTargets.cmake")
endif()
if (OFF)
  include("${CMAKE_CURRENT_LIST_DIR}/chameleon_parsecTargets.cmake")
endif()
if (OFF)
  include("${CMAKE_CURRENT_LIST_DIR}/chameleon_quarkTargets.cmake")
endif()
if (OFF)
  include("${CMAKE_CURRENT_LIST_DIR}/chameleon_starpuTargets.cmake")
endif()
include("${CMAKE_CURRENT_LIST_DIR}/chameleonTargets.cmake")
